<template>
  <svg :width="width" :height="height" class="barChart"> 
    <g class="yGridLines" ref="yGridLines" 
      :transform="`translate(${margin.left}, 0)`"/>
    <path v-for="line in lines" 
      :key="line.id" 
      :d="line.path"
      :stroke="line.fill" 
      fill="none"
    />
    <g class="yAxis" ref="yAxis" 
      :transform="`translate(${margin.left}, 0)`"/>
    <g class="xAxis" ref="xAxis" 
      :transform="`translate(0, ${height - margin.bottom})`" />
  </svg >
</template>

<script>
import * as d3 from 'd3' 
import {TweenMax} from 'gsap'

export default {
  props: ['data'], 
  data () {
    return {
      width: 850,
      height: 250,
      margin: { top: 25, right: 20, bottom: 25, left: 35 },
      lines: [],
    }
  },

  methods: {
    renderAxes () {
      const xAxis = d3.axisBottom().scale(this.xScale).ticks(9)
              .tickFormat(d3.timeFormat("%b %y"))
      const yAxis = d3.axisLeft().scale(this.yScale).tickFormat(d => `${d}°C`)
      const yGridLines = d3.axisLeft().scale(this.yScale)
              .tickSize(-1 * (this.width - (this.margin.left + this.margin.right)) , 0, 0)
              .tickFormat('')
      d3.select(this.$refs.xAxis).call(xAxis)
      d3.select(this.$refs.yAxis).call(yAxis)
      d3.select(this.$refs.yGridLines).call(yGridLines)
    },

    calcScales () {
      const extent = d3.extent(this.data, d => d.date)
 
      this.xScale = d3.scaleTime()
        .domain(extent)
        .range([this.margin.left, this.width - this.margin.right])

      this.yScale = d3.scaleLinear()
        .domain([-15, 40])
        .range([this.height - this.margin.bottom, this.margin.top])
     },

    calcLines() {
      const line = d3.line().x(d => this.xScale(d.date))
      this.lines = [
        {path: this.lines[0] ? this.lines[0].path : line.y(() => this.yScale(0))(this.data), 
         newPath: line.y(d => this.yScale(d.high))(this.data),
         fill: '#e14733'},
        {path: this.lines[1] ? this.lines[1].path : line.y(() => this.yScale(0))(this.data),
         newPath: line.y(d => this.yScale(d.low))(this.data), 
         fill: '#99c1d3'},
      ]
    },

    animate () {
      TweenMax.staggerFromTo(this.lines, .75, {
        // from
        cycle: {
         path : (i) => this.lines[i].path,
        }
      }, {
        // to
        cycle: {
          path : (i) => this.lines[i].newPath,
        },
      })
    },
  },
  watch: {
    data () {
     this.calcScales()
     this.renderAxes()
     this.calcLines()
     this.animate()
    },
  },
}
</script>

<style>
body {
  background: #383c4a;
}

.xAxis line, .yAxis line {
  stroke: #ccc;
}

.xAxis path, .yAxis path {
  stroke: #ccc;
}

.xAxis text, .yAxis text {
  color: #ccc;
}

.yAxis path, .yGridLines path {
  stroke: none;
}

.yGridLines line {
  stroke: #ccc;
  stroke-width: 1px;
  stroke-opacity: .2;
}

.barChart {
  border: #ccc 0px solid;
}

#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 60px;
}
</style>
